//@Kecven

import java.io.*;
import java.util.ArrayList;
import java.util.List;

public class WayRayCompetitions {
	public static void main(String[] args) throws InterruptedException {

// процесор с 4мя ядрами!
//Оценка результатов
//Если delta — ошибка определения координат в метрах и T — время затраченное на вычисление, то количество баллов вычисляется по формуле
// 100/(delta+10) + 10/(T+1).
// Если время работы более 5 секунд на процессоре i7-3820 с HT или ошибка определения координат превышает 1000 метров — то результат не засчитывается. Баллы по всем тестам суммируются.
//Переводы строк — не документированы, лучше на это не закладываться.
//Округление координат спутников создает слишком много неясностей. Гарантируется точность координат спутников до 1мм (3 знака после запятой в метрах). Качайте новый файл — в него добавлен 3-й тест с высокой точностью. Все тесты для финального тестирования перегенерированы с высокой точностью.
		//--------------------------------------------------------------------------------------------------------------------
		//--------------------------------------------------------------------------------------------------------------------
		//--------------------------------------------------------------------------------------------------------------------
//		long time = System.currentTimeMillis();
		//--------------------------------------------------------------------------------------------------------------------
		//--------------------------------------------------------------------------------------------------------------------
		//--------------------------------------------------------------------------------------------------------------------

		ArrayList<FindPoint> thread = new ArrayList<FindPoint>(3);

		thread.add(new FindPoint((byte) 2));
		thread.add(new FindPoint((byte) 5));
		thread.add(new FindPoint((byte) 8));
		byte proces = 0;
/*		try {
			BufferedReader bReader = new BufferedReader(new FileReader("file/test1.in"));
			String line = null;
			String numberString = bReader.readLine();
			Data.number = Short.parseShort(numberString);
			for (byte i = 0; i < Data.number; i++){
				line = bReader.readLine();
				Data.x[i] = Double.parseDouble(line);
				line = bReader.readLine();
				Data.y[i] = Double.parseDouble(line);
				Data.sequence[i] = bReader.readLine();


				//Запускаем максимум 3 процесса, т.к. машина 4х ядерная
				//Когда просчитали 3 последующие точки
				//Если ещё будет читать больше 3х данных. Надежда на то, что эти данные будут читаться какое то время, а пока они будут читаться, всё уже прощитается
				if( proces < 3 && i % 3 == 2 && ((Data.number-3 < i) || (proces == 0))) {
					thread.add(new FindPoint(i));
					thread.get(thread.size()-1).start();
					proces++;
				}

			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}catch (IOException e) {
			e.printStackTrace();
		}
		if (Data.number == 2){
			thread.add(new FindPoint((byte) 2));
			thread.get(0).start();
			proces = 1;
		}
*/
		BufferedReader keyboard = new BufferedReader(new InputStreamReader(System.in));
		try {
			String line = keyboard.readLine();
			Data.number = Short.parseShort(line);
			for (byte i = 0; i < Data.number; i++){
				line = keyboard.readLine();
				Data.x[i] = Double.parseDouble(line);
				line = keyboard.readLine();
				Data.y[i] = Double.parseDouble(line);
				Data.sequence[i] = keyboard.readLine();

				//Запускаем максимум 3 процесса, т.к. машина 4х ядерная
				//Когда просчитали 3 последующие точки
				//Если ещё будет читать больше 3х данных. Надежда на то, что эти данные будут читаться какое то время, а пока они будут читаться, всё уже прощитается
				if( proces < 3 && i % 3 == 2 && ((Data.number-3 < i) || (proces == 0))) {
//					thread.add(new FindPoint(i));
					thread.get(proces).start();
					proces++;
				}

			}
		}catch (IOException e) {
			e.printStackTrace();
		}

		if (Data.number == 2){
//			thread.add(new FindPoint((byte) 2));
			thread.get(0).start();
			proces = 1;
		}

//Данные введены

		//--------------------------------------------------------------------------------------------------------------------
		//--------------------------------------------------------------------------------------------------------------------
		//--------------------------------------------------------------------------------------------------------------------
//		System.out.println("Время на чтение файла: " + (System.currentTimeMillis() - time));
//		time = System.currentTimeMillis();
		//--------------------------------------------------------------------------------------------------------------------
		//--------------------------------------------------------------------------------------------------------------------
		//--------------------------------------------------------------------------------------------------------------------



//Исходная последовательность прощитана


		//double[] xy = pointMove(x[0], y[0], r1, x[1], y[1], r2);

		//--------------------------------------------------------------------------------------------------------------------
		//--------------------------------------------------------------------------------------------------------------------
		//--------------------------------------------------------------------------------------------------------------------
//		System.out.println("Нахождение точки: " + (System.currentTimeMillis() - time));
//		time = System.currentTimeMillis();
		//--------------------------------------------------------------------------------------------------------------------
		//--------------------------------------------------------------------------------------------------------------------
		//--------------------------------------------------------------------------------------------------------------------


/*
		if(number == 2)//Если только 2 спутника - то выводим первую точку
			System.out.println(xy[0] + " " + xy[1]);
		//Если спутников несколько ищем ближайшую точку и выводим её
		else{

			int r3 = (int) (sequence[2].indexOf(originalSequence) * 29.9792458);
			if( Math.abs(Math.sqrt((xy[0] - x[2])*(xy[0] - x[2]) + (xy[1] - y[2])*(xy[1] - y[2])) - r3) <
				Math.abs(Math.sqrt((xy[2] - x[2])*(xy[2] - x[2]) + (xy[3] - y[2])*(xy[3] - y[2])) - r3) )
				System.out.println(xy[0] + " " + xy[1]);
			else
				System.out.println(xy[2] + " " + xy[3]);
		}

*/
		for (FindPoint f : thread){
			f.join();
		}

		double x = 0;
		double y = 0;

		for (Double d : Data.resultX){
			x += d;
		}
		for (Double d : Data.resultY){
			y += d;
		}
		x /= proces;
		y /= proces;
		System.out.println(x + " " + y);

		//--------------------------------------------------------------------------------------------------------------------
		//--------------------------------------------------------------------------------------------------------------------
		//--------------------------------------------------------------------------------------------------------------------
//		System.out.println("Время на нахождение точек: " + (System.currentTimeMillis() - time));
		//--------------------------------------------------------------------------------------------------------------------
		//--------------------------------------------------------------------------------------------------------------------
		//--------------------------------------------------------------------------------------------------------------------

	}



}



class FindPoint extends Thread{

	private static byte i;

	FindPoint(byte i){
		this.i = i;
	}

	@Override
	public void run() {

		double r1 = (Data.sequence[i-2].indexOf(Data.originalSequence) * 29.9792458);
		double r2 = (Data.sequence[i-1].indexOf(Data.originalSequence) * 29.9792458);

/*
		System.out.println("x1 = " + Data.x[i-2]);
		System.out.println("y1 = " + Data.y[i-2]);
		System.out.println("r1 = " + r1);
		System.out.println("x2 = " + Data.x[i-1]);
		System.out.println("y2 = " + Data.y[i-1]);
		System.out.println("r2 = " + r2);

*/

		double[] xy = pointMove(Data.x[i-2], Data.y[i-2], r1, Data.x[i-1], Data.y[i-1], r2);
/*
		System.out.println("x1 = " + xy[0]);
		System.out.println("y1 = " + xy[1]);
		System.out.println("x2 = " + xy[2]);
		System.out.println("y2 = " + xy[3]);
*/
		if (Data.number > 2) {
			double r3 = (Data.sequence[i].indexOf(Data.originalSequence) * 29.9792458);

			if (Math.abs(Math.sqrt((xy[0] - Data.x[i]) * (xy[0] - Data.x[i]) + (xy[1] - Data.y[i]) * (xy[1] - Data.y[i])) - r3) <
					Math.abs(Math.sqrt((xy[2] - Data.x[i]) * (xy[2] - Data.x[i]) + (xy[3] - Data.y[i]) * (xy[3] - Data.y[i])) - r3)) {
				Data.resultX.add(xy[0]);
				Data.resultY.add(xy[1]);
			} else {
				Data.resultX.add(xy[2]);
				Data.resultY.add(xy[3]);
			}
		}
		else{
			Data.resultX.add(xy[0]);
			Data.resultY.add(xy[1]);
		}

	}

	//Функция находит 2 точки пересечения 2х окружностей. Возвращает массив
	//int для переменных хватит, но тогда дальше прийдётся приводить типы
	private static double[] pointMove (double x1, double y1, double r1, double x2, double y2, double r2){

		double d =  Math.sqrt(((x1-x2)*(x1-x2)) + ((y1-y2)*(y1-y2)));
		double u = (d + (r1*r1 - r2*r2) / d) / 2;

		double h = Math.sqrt(r1 * r1 - u * u);
		double x = x1+(x2-x1)/d*u-(y2-y1)/d*h;
		double y = y1+(y2-y1)/d*u+(x2-x1)/d*h;

		double R1=r1/d;
		double R2=r2/d;

		u = (1 + R1*R1 - R2*R2) / 2;

		h = Math.sqrt((R1*R1)-(u*u));

		double X1=x1+(x2-x1)*u;
		double Y1=y1+(y2-y1)*u;

		double X2=(y1-y2)*h;
		double Y2=(x2-x1)*h;

		return new double[]{(X1+X2), (Y1+Y2), (X1-X2), (Y1-Y2)};
	}



}

class Data{
	public static String[] sequence = new String[255];            //Переданные последовательности
	public static double[] x = new double[255];
	public static double[] y = new double[255];                         //Массивы иксов и игриков с координатами спутников
	public static List<Double> resultX = new ArrayList<Double>(3);
	public static List<Double> resultY = new ArrayList<Double>(3);                    //Массивы иксов и игриков с координатами местоположения
	//Исходная последовательность, первые 171 уникальный символ
	public static String originalSequence = "111111111111111111111111111111000000000000000000001111111111111111111100000000000000000000000000000011111111111111111111111111111100000000001111111111111111111100000000001";
	public static short number = 2;

}