//@Tameilan
//package glonass;

import java.io.*;
import static java.lang.Math.*;

public class Glonass {
    static final double cv=29.9792458;
    static final double ds=1;
    static final String p1="1111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111";
    static final String p2="000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000";
    static final int sp1=6375480;
    static final int sp2=427400;

    static double[] x, y, r0, ri;
    static String[] p;
    static int k, l, m;
    static boolean flag=true;
    
    public static void main(String[] args) throws IOException {

        class RThread extends Thread {
            int n;

            public RThread(int n){
                this.n=n;
            }

            @Override
            public void run(){
                int d1, d2;
                d1=p[n].indexOf(p1);
                d2=p[n].indexOf(p2);
                if(d1!=-1){
                    ri[n]=((10000000+d1-sp1)%10000000)*cv;
                }else{
                    ri[n]=((10000000+d2-sp2)%10000000)*cv;
                }
            }
        }
    
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        int N = Integer.parseInt(in.readLine());
        
        RThread[] rt;
        rt = new RThread[N];
        ri = new double[N];
        r0 = new double[N];
        x = new double[N];
        y = new double[N];
        p = new String[N];
        double a, b, c;
        double d, e, x1, x2, y1, y2;
        double r1, r2;
        int i=0;
        k=0;
        l=0;
        m=0;
        while((i<N)&&flag){
            x[i]=Double.parseDouble(in.readLine());
            y[i]=Double.parseDouble(in.readLine());
            p[i]=in.readLine();
            k=i;
            l=0;
e:            
            while(flag&&l<k-1){
                m=l;
                while(flag&&m<k-1){
                    d=abs((x[m]-x[l])*(y[k]-y[l])-(x[k]-x[l])*(y[m]-y[l]));
                    if(d>=ds){
                        flag=false;
                        break e;
                    }else{
                        m++;
                    }
                }
                l++;
            }
            (rt[i]=new RThread(i++)).start();
        }
        int j=i;

        i=1;
        do{
            if(!rt[i].isAlive()){
                i++;
            }
        }while(i<j);
        
        r1=ri[k];
        r2=ri[l];
        x1=x[k];
        x2=x[l];
        y1=y[k];
        y2=y[l];

        b=(x1-x2)/(y2-y1);
        a=(r1*r1-r2*r2-x1*x1+x2*x2-y1*y1+y2*y2)/(2*y2-2*y1);
        c=1+b*b;
        d=x1+b*y1-a*b;
        e=sqrt(d*d-c*(x1*x1+a*a-2*a*y1+y1*y1-r1*r1));
        x1=(d+e)/c;
        x2=(d-e)/c;
        y1=a+b*x1;
        y2=a+b*x2;
        if(sqrt(x1*x1+y1*y1)>6378000){
            System.out.println(x2+" "+y2);
        }else if(sqrt(x2*x2+y2*y2)>6378000){
            System.out.println(x1+" "+y1);
        }else if(N>2){
            r1=sqrt((x[m]-x1)*(x[m]-x1)+(y[m]-y1)*(y[m]-y1));
            r2=sqrt((x[m]-x2)*(x[m]-x2)+(y[m]-y2)*(y[m]-y2));
            if(abs(ri[m]-r1)<abs(ri[m]-r2)){
                System.out.println(x1+" "+y1);
            }else{
                System.out.println(x2+" "+y2);
            }
        }else{
            System.out.println(x1+" "+y1);
        }
    }
}
