//@d954mas
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.security.NoSuchAlgorithmException;
public class GlonassToSend {
    final static int delta=10000;
    final static double c=299792458.0;
    final static int intToTest=-432310397;
    public static void main(String[] a) throws NoSuchAlgorithmException, IOException
    {   BufferedReader reader=new BufferedReader(new InputStreamReader(System.in));
        int numberOfSputnik=Integer.parseInt(reader.readLine());
        if(numberOfSputnik>10)numberOfSputnik=10;
        double[] coordsX=new double[numberOfSputnik];
        double[] coordsY=new double[numberOfSputnik];
        double[] distance=new double[numberOfSputnik];
        for(int i=0;i<numberOfSputnik;i++)
        {
            coordsX[i]=Double.parseDouble(reader.readLine());
            coordsY[i]=Double.parseDouble(reader.readLine());
            distance[i]=getShiftOfSequence(readSequence(reader))/10000000.0*c;
        }
        reader.close();
        double [][][] possibleCoords=new double[numberOfSputnik][numberOfSputnik][4];
        for(int i=0;i<numberOfSputnik-1;i++)
        {
            for(int z=i+1;z<numberOfSputnik;z++)
            {
                possibleCoords[i][z]=getCyrcleAnd(coordsX[i],coordsY[i],coordsX[z]
                        ,coordsY[z],distance[i],distance[z]);
                possibleCoords[z][i]=possibleCoords[i][z];
            }
        }
        for(int j=0;j<2;j++)
        {
            double possibleX=possibleCoords[0][1][j*2];
            double possibleY=possibleCoords[0][1][j*2+1];
            double possibleXsum=possibleCoords[0][1][j*2];
            double possibleYsum=possibleCoords[0][1][j*2+1];
            for(int i=0;i<numberOfSputnik-1;i++)
            {
                if(Math.abs(possibleX)>6378000 || Math.abs(possibleY)>6378000)break;
                if(possibleX-possibleCoords[i][i+1][0]<delta && possibleY-possibleCoords[i][i+1][1]<delta)
                {
                     possibleXsum+=possibleCoords[i][i+1][0];
                     possibleYsum+=possibleCoords[i][i+1][1];
                }
                else if(possibleX-possibleCoords[i][i+1][2]<delta && possibleY-possibleCoords[i][i+1][3]<delta)
                {
                    possibleXsum+=possibleCoords[i][i+1][2];
                    possibleYsum+=possibleCoords[i][i+1][3];
                }
                else break;
                if(i==numberOfSputnik-2)
                {
                    System.out.println(possibleXsum/numberOfSputnik+" "+possibleYsum/numberOfSputnik);
                    return;
                }
            }
        }
    }
    static int getShiftOfSequence(String sequence)
    {
        char[] sequenceChars=sequence.toCharArray();
        int shift=0;
        char firstChar=sequenceChars[0];
        for(int i=0;i<200;i++)
        {
            if(sequenceChars[i]==firstChar)shift++;
            else break;
        }
        shift=shift%10;
        if(shift==0)shift=10;
        int n=0;
        for(int i=shift+200;i<1000000;i+=1)
        {
            if(n==intToTest)return i*10+shift-2130;
            else n=(n<<1)+Integer.parseInt(""+sequenceChars[i]);
        }
        return -1;
    }
    static  double[] getCyrcleAnd(double x1,double y1,double x2,double y2,double r1,double r2)
    {
        double[] result=new double[4];
        double d=Math.sqrt(Math.pow(x1-x2,2)+Math.pow(y1-y2,2));
        double a=(Math.pow(r1,2)-Math.pow(r2,2)
                +Math.pow(d,2))/(2.0*d);
        double h=Math.sqrt(Math.pow(r1,2)-Math.pow(a,2));
        double p0x=x1+a*(x2-x1)/d;
        double p0y=y1+a*(y2-y1)/d;
        double xSame=p0x+h*(y2-y1)/d;
        double ySame=p0y-h*(x2-x1)/d;
        double xSame2=p0x-h*(y2-y1)/d;
        double ySame2=p0y+h*(x2-x1)/d;
        result[0]=xSame;
        result[1]=ySame;
        result[2]=xSame2;
        result[3]=ySame2;
        return result;
    }
    static String readSequence(BufferedReader reader) throws IOException {
        StringBuilder builder=new StringBuilder();
        for(int i=0;i<200;i++)
        {
            builder.append(Character.toChars(reader.read()));
        }
        for(int i=210;i<100000;i++)
        {
            builder.append(Character.toChars(reader.read()));
            reader.skip(9);
        }
        reader.skip(9001900);
        while (reader.ready())
        {
            if(reader.read()=='\n')break;
        }
        return builder.toString();
    }
}