//@vshantarin
//sorry if this is horrible
import java.io.*;
import java.util.*;

class Pt { // 2d point
	public double x;
   	public double y;
   	public Pt(double _x, double _y) {
   		x = _x;
   	   	y = _y;
   	}
   	public double dist(Pt a) {
   	   	return Math.sqrt((x - a.x) * (x - a.x) + (y - a.y) * (y - a.y));
   	}
   	public double angle(Pt a, Pt b) { //between (this, a) and (a, b)
   	   	double a1 = y - a.y, b1 = a.x - x;
   	   	double a2 = b.y - a.y, b2 = a.x - b.x;
   	   	if (a1 * a2 + b1 * b2 < 1e-3)
   	   		return Math.PI;
   	   	else
   	   		return Math.abs(Math.atan((a1*b2 - a2*b1) / (a1*a2 + b1*b2)));
   	}
   	public String toString() {
   	   	return "" + x + " " + y;
   	}
}

class Ans { // answer : 1 or 2 points and best angle
	public Pt pt1;
	public Pt pt2;
	public double angle;
	public Ans(Pt _pt1, Pt _pt2, double _angle) {
	   	pt1 = _pt1;
	   	pt2 = _pt2;
	   	angle = _angle;
	}
	public void makeBetter(Ans newAns) {
	   	if (newAns.pt1 == null)
	   		return;
	   	if (pt2 == null) {
	   	   	if (newAns.pt2 == null)
	   	   		pt1 = newAns.pt1;
	   	   	else if (pt1.dist(newAns.pt1) < pt1.dist(newAns.pt2))
	   	   		pt1 = newAns.pt1;
	   	   	else
	   	   		pt2 = newAns.pt2;
	   	}
	   	else if (newAns.pt2 == null) {
	   	   	pt1 = newAns.pt1;
	   	   	pt2 = newAns.pt2;
	   	}
	   	else {
	   	   	Pt newPt1 = pt1.dist(newAns.pt1) < pt1.dist(newAns.pt2)      ?     newAns.pt1     :     newAns.pt2;
	   	   	Pt newPt2 = pt2.dist(newAns.pt1) < pt2.dist(newAns.pt2)      ?     newAns.pt1     :     newAns.pt2;
	   	   	double d1 = pt1.dist(newPt1);
	   	   	double d2 = pt2.dist(newPt2);
	   	   	if (d1 * 100 < d2) {
	   	   	   	pt1 = newPt1;
	   	   	   	pt2 = null;
	   	   	}
	   	   	else if (d2 * 100 < d1) {
	   	   	   	pt1 = newPt2;
	   	   	   	pt2 = null;
	   	   	}
	   	   	else {
	   	   	   	pt1 = newPt1;
	   	   	   	pt2 = newPt2;
	   	   	}
	   	}
	   	angle = newAns.angle;
	}
	public boolean isGood() {
	   	return pt1 != null && pt2 == null && Math.abs(Math.PI - angle) < 1;
	}
	public boolean isBetterThan(Ans ans) {
	   	return Math.abs(Math.PI - angle) < Math.abs(Math.PI - ans.angle);
	}
	public String toString() {
   	   	return "" + pt1 + " " + pt2;
   	}
}

class Sat {
	public Pt pt;
   	public double r;
   	public Ans intersect(Sat s) {
   		double a = -2 * (s.pt.x - pt.x), b = -2 * (s.pt.y - pt.y), c = (s.pt.x - pt.x)*(s.pt.x - pt.x) + (s.pt.y - pt.y)*(s.pt.y - pt.y) + r*r - s.r * s.r;
		double x0 = -a*c/(a*a+b*b),  y0 = -b*c/(a*a+b*b);
		if (Math.abs(c*c - r*r*(a*a+b*b)) < 30) {
		   	Pt result = new Pt(x0 + pt.x, y0 + pt.y);
			return new Ans(result, null, pt.angle(result, s.pt));
		}
		else {
			double d = r*r - c*c/(a*a+b*b);
			double mult = Math.sqrt (d / (a*a+b*b));
			double ax,ay,bx,by;
			ax = x0 + b * mult;
			ay = y0 - a * mult;
			bx = x0 - b * mult;
			by = y0 + a * mult;
			Pt pt1 = new Pt(ax + pt.x, ay + pt.y);
			//System.out.println(pt1);
			Pt pt2 = new Pt(bx + pt.x, by + pt.y);
			//System.out.println(pt2);
			if (pt1.dist(new Pt(0, 0)) > 6380000)
				pt1 = null;
			if (pt2.dist(new Pt(0, 0)) > 6380000)
				pt2 = null;
			if (pt1 == null) {
				pt1 = pt2;
				pt2 = null;
			}
			return new Ans(pt1, pt2, pt.angle(pt1, s.pt));
		}
   	}
}

public class Main {
    public static void main(String[] args) throws Exception {
        new Main().run();
    }

    void run() throws Exception {
       Locale.setDefault( Locale.US );
        //br = new BufferedReader(new FileReader("/home/vladimir/Downloads/glonass-contest/test3.in"), 11_000_000);
        //br = new BufferedReader(new FileReader("/home/vladimir/code/pain/output.txt"), 11_000_000);
        //br = new BufferedReader(new FileReader("/home/vladimir/Downloads/mytest2.txt"), 42_000_000);
        br = new BufferedReader(new InputStreamReader(System.in), 11_000_000);

        beginTime = System.currentTimeMillis();
        solve();
        System.out.flush();
    }

	class DistanceComputer implements Runnable {
	   	public void run() {
	      	char[] str = new char[10_000_000];
	      	String sx = "", sy = "";
	      	while (!good) {
		      	synchronized (br) {
		      	   try {
		      	      if (System.currentTimeMillis() - beginTime > 4500)
		      	      	return;
		      	   	sx = br.readLine();
		      	   	if (sx == null)
		      	   		return;
		      	   	else if (sx.isEmpty())
		      	   		sx = br.readLine();
		      	   	if (sx == null)
		      	   		return;
		      	   	sy = br.readLine();
		      	   	br.read(str, 0, 10_000_000);
		      	   } catch (Exception e) {
		      	      return;
		      	   }
		      	}

		      	Sat curSat = new Sat();
		      	curSat.pt = new Pt(Double.parseDouble(sx), Double.parseDouble(sy));

	         		int cur = 1;
	         		while (str[cur] == str[0])
	         			 ++cur;
	         		int smallOffset = cur % 10;

	         		int curSeq = 0, pos = -18, sample = 0b111001100011101101;
	         		for (int i = 0; curSeq != sample; i += 10) {
	         			curSeq = ((curSeq << 1) & 0x3ffff) + (str[i] - '0');
	         			++pos;
	         		}
	         		pos *= 10;

	         		if (smallOffset != 0)
	         			pos += smallOffset - 10;

	         		curSat.r = pos * 29.9792458 - 10;

	         		synchronized (vec) {
	         		   	if (!vec.isEmpty())
	         		   	{
	         		   	   	Ans bestAns = null;
	         		   		for (Sat j : vec) {
	         		   		   	Ans curAns = j.intersect(curSat);
	         		   		   	if (bestAns == null || curAns.isBetterThan(bestAns))
	         		   		   		bestAns = curAns;
	         		   		}
	         		   		if (ans == null)
	         		   			ans = bestAns;
	         		   		else if (bestAns.isBetterThan(ans))
	         		   			ans.makeBetter(bestAns);
	         		   		if (ans.isGood())
		         		   			good = true;
		         		}

	         		   	vec.add(curSat);
	         		}

	         		//System.out.println("" + pos + " dist: " + pos * 29.9792458 + "m");
	      	}
		}
	}

    	static public BufferedReader br;
	static public volatile boolean good = false;
    	static public Vector<Sat> vec = new Vector<Sat>(255);
    	static public Ans ans;
    	static public double beginTime;

	void solve() throws Exception {
	       int n = Integer.parseInt(br.readLine());
 	       int threadsCount = Math.min(n / 3 + 1, 5); // hope it worth it...
	       Thread ths[] = new Thread[threadsCount];
	       for (int i = 0; i < threadsCount; ++i)
	          	(ths[i] = new Thread(new DistanceComputer())).start();
	       for (int i = 0; i < threadsCount; ++i)
	       	ths[i].join();
	       System.out.println("" + ans.pt1.x + " " + ans.pt1.y);
	}
}