//@josdas
import java.io.*;

public class Q{
public static double x[], y[], L[], u = 29.9792458, l, rx, ry, x1, y1, x2, y2;
public static int n;

public static double hypot(double xx, double yx, double x1, double y1){
xx-=x1; yx-=y1;
return Math.sqrt(xx*xx+yx*yx);
}

public static double F(double xx, double yy){
	double f = 0;
	for(int i = 0; i< n; i++) f+=Math.abs(Math.sqrt((xx-x[i])*(xx-x[i])+(yy-y[i])*(yy-y[i]))-L[i]);
	return f;
}


public static void hy(int i, int j){
	double xf = x[j] - x[i], yf = y[j]-y[i], d, bl, h, r1 = L[i], r2 = L[j], ox, oy, q1x, q1y, q2x, q2y;
	d=Math.sqrt(xf*xf+yf*yf);
	bl=(d*d-r1*r1+r2*r2)/2/d;
	h=Math.sqrt(r2*r2-bl*bl);
	ox=(d-bl)/d*xf; oy=(d-bl)/d*yf;
	xf=xf-ox; yf=yf-oy;
	y1=xf/bl*h+oy+y[i];
	x1=-yf/bl*h+ox+x[i];
	y2=-xf/bl*h+oy+y[i];
	x2=yf/bl*h+ox+x[i];
}

public static void main (String[] args) throws java.lang.Exception
    {
		PrintWriter outs = new PrintWriter(System.out);
		BufferedReader bf = new BufferedReader (new InputStreamReader(System.in));
		int i, j, t, q, k, w, c;
		n = Integer.parseInt(bf.readLine());
		
		x = new double[n];
		y = new double[n];
		L = new double[n];
		boolean F[] =  new boolean[1000100];
		int P[] = new int[1000000];
		String sd = "1110011000111011011101111000001100110011100101010100110000111110110000110111010111111000110010001000";
		
		for(i = 0; i < 100; i++) F[i] = (sd.charAt(i) == '1');
		
		for(c = 0; c < n; c++){
			x[c] = Double.parseDouble(bf.readLine());
			y[c] = Double.parseDouble(bf.readLine());
			String s = bf.readLine();
			for(l = t = w = k = i = 0; i < 10000000 && k < 1000000;i++){
				q = s.charAt(i) - '0';
				if(q != w){
					if(t%10 != 0){
						F[k+100] = w > 0;
						k++;
						l = t%10;
					}
					t = 0;
					w = q;
				}
				t++;
				if(t%10 == 0){
					F[k+100] = q>0;
					k++;
				}
				
			}
			
			for(i=1; i<1000100; i++) if(i != 100){
				j=P[i-1];
				while(j>0 && F[i]!=F[j])j=P[j-1];
				if(F[j]==F[i])j++;
				P[i]=j;
				if(j == 100){
					l+=(i-200)*10;
					break;
				}
			}
			
			L[c] = l*u;
		}
		
		if(n == 2){
			hy(0, 1);
			if(hypot(x1, y1, 0, 0)<6378000){
				rx = x1;
				ry = y1;
			}
			else {
				rx = x2;
				ry = y2;
			}
		}
		else{
			int df = 0;
			for(i = 0; i < n; i++) for(j = 0; j< n; j++) for(k = 0; k< n; k++)if(j!=i && j!=k && k!=i){
				df++;
				hy(i, j);
				double xx1=x1, xx2=x2, yy1=y1, yy2=y2, h11, h12, h21, h22;
				hy(i, k);
				h11=hypot(xx1, yy1, x1, y1);
				h12=hypot(xx1, yy1, x2, y2);
				h21=hypot(xx2, yy2, x1, y1);
				h22=hypot(xx2, yy2, x2, y2);
				if(h11<h22&&h11<h12&&h11<h21){
					rx+=(xx1+x1)/2;
					ry+=(yy1+y1)/2;
				}
				else if(h12<h22&&h12<h11&&h12<h21){
					rx+=(xx1+x2)/2;
					ry+=(yy1+y2)/2;
				}
				else if(h22<h12&&h22<h11&&h22<h21){
					rx+=(xx2+x2)/2;
					ry+=(yy2+y2)/2;
				}
				else {
					rx+=(xx2+x1)/2;
					ry+=(yy2+y1)/2;
				}
			}
			rx/=df;
			ry/=df;
		}
		double p = F(rx, ry);
		for(i = 0; i < 10000; i++){
			double wf = (0.5-Math.random())*((11005-i)/(10000)*10), ef = (0.5-Math.random())*((11005-i)/(10000)*10), sdf;
			sdf = F(rx+wf, ry+ef);
			if(p>sdf){
				p = sdf;
				rx += wf;
				ry += ef;
			}
		
		}
		outs.print(rx + " " +ry);
		outs.flush();
	}
}