//@kotomord82
import java.util.Scanner;
public class Contest{
    static final int mI =  30000001;
    static final int lI = 10000000;
    static int[] m7 = new int[mI];
    static int[] p7 = new int[lI];
    static int[] df = new int[mI];
    static{
        for(int i =1;i< mI; ++i) {
            m7[i] = m7[i-1] + 7;
            if(m7[i]>= mI)  m7[i]-= mI;
        }
        p7[0] = 1;
        for(int i=1; i< lI; ++i){
            p7[i] = m7[p7[i-1]];
        }
        int b = 14595674;
        for(int i =0; i< lI; ++i){
            df[b] = i;
            b = m7[b];
        }
    }
    static  int diff(String s){
        int hsh =0;
        for(int i =0; i< lI; ++i){
            if(s.charAt(i)=='1') {
                hsh+=p7[i];
                if(hsh>= mI) hsh-= mI;
            }
        }
        return df[hsh];
    }
    static final  double speed = 299792458.;
    static final int  rad   = 6378000;
    static class Point{
        double x;
        double y;
        int pdiff;
        double r;
   }
    static  double resx1;
    static  double resx2;
    static  double resy1;
    static  double resy2;
    static void init2Result(Point p1, Point p2){
        double d1 = dist(p1.x, p1.y, p2.x, p2.y);
        double d2 = p1.r;
        double d3 = p2.r;
        double cosx = (d1*d1+d2*d2-d3*d3)/2/d1/d2;
        if(Math.abs(cosx)<1e-7){
            if(cosx<0) cosx= -1;
            else cosx = -1;
        }
        double sinx = Math.sqrt(1-cosx*cosx);
        double vecx = p2.x - p1.x;
        double vecy = p2.y - p1.y;

        resx1 = p1.x + (vecx*cosx + vecy*sinx)*d2/d1;
        resy1 = p1.y + (- vecx*sinx + vecy*cosx)*d2/d1;
        sinx*=-1;
        resx2 = p1.x + (vecx*cosx + vecy*sinx)*d2/d1;
        resy2 = p1.y + (- vecx*sinx + vecy*cosx)*d2/d1;
        double   root1 = dist(resx1,resy1);
        if(root1>rad+1){
            System.out.println(resx2 + " " + resy2);
            System.exit(0);
        }
        double root2 =   dist(resx2, resy2);
        if(root2>rad+1){
            System.out.println(resx1 + " " + resy1);
            System.exit(0);
        }
    }
   static  double dist (double x, double y){
        return Math.sqrt(x*x+y*y);
    }
    static  double dist(double x1, double y1, double x2, double y2){
        return dist(x1-x2,y1-y2);
    }

   public static  void main(String[] args){
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        Point p1 = new Point();
        p1.x = Double.valueOf(sc.next());
        p1.y = Double.valueOf(sc.next());
        p1.pdiff = diff(sc.next());
        Point p2 = new Point();
        p2.x = Double.valueOf(sc.next());
        p2.y = Double.valueOf(sc.next());
        p2.pdiff = diff(sc.next());
        p1.r=speed*(p1.pdiff)/ lI;
        p2.r=speed*(p2.pdiff)/ lI;
        init2Result(p1,p2);
        for(int i =2; i<n; ++i){
           double x =  Double.valueOf(sc.next());
           double y = Double.valueOf(sc.next());
           if(inLine(x,y)) {
               sc.next();
           } else{
             int diff3 = diff(sc.next());
             double r3 = speed*diff3/ lI;
             double d1 = Math.abs(dist(x, y, resx1, resy1)-r3);
             double d2 = Math.abs(dist(x, y, resx2, resy2) - r3);
             if(d1<d2){
                 System.out.println(resx1 + " " + resy1);
             } else{
                 System.out.println(resx2 + " " + resy2);
             }
               System.exit(0);
           }
       }
        System.out.println(resx1 + " " + resy1);

    }

    private static boolean inLine(double x, double y) {
        double x1= x-resx1;
        double x2 =x-resx2;
        double y1= x-resy1;
        double y2 =x-resy2;
       return Math.abs(x1*x1+y1*y1 - x2*x2 - y2*y2)<10;
    }

}
