//@murzin
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.security.MessageDigest;
public class Solver {
    static final int LOW = 33000;
    static final int HIGH = 67000;
    public static void main(String[] args) {
        int[] x, y, r;
        byte[] bytes = new byte[16];
        Byte satNumber = 0;
        char[] bt = new char[34000];
        String hash;
        InputStreamReader ISR;
        ISR = new InputStreamReader(System.in);
        BufferedReader     BR = new BufferedReader(ISR);
            try {
                MessageDigest md = MessageDigest.getInstance("MD5");
                for (int i = 0; i < 34000; i++) {
                    String s = "3.1415926535897932384626433832795028841971693993751058209749445923078164062862089986280348253421170679821480865132823066470938446" + Integer.toString(i);
                    bytes = md.digest(s.getBytes());
                    if (((bytes[0] >> 4) & 0x0F) > 7) {bt[i] = '1';} else {bt[i] = '0';}
                }
            } catch (Exception e) {}
        try {
            satNumber = Byte.valueOf(BR.readLine());
            if (satNumber > 15) {satNumber = 15;}
         } catch (Exception e) {}
        x = new int[satNumber];
        y = new int[satNumber];
        r = new int[satNumber];
        for (byte j = 0; j < satNumber; j++) {
            try {
                x[j] = (int) (double)Double.valueOf(BR.readLine());
                y[j] = (int) (double)Double.valueOf(BR.readLine());
                hash = BR.readLine();
                char pr = '0', cu ='0';
                int count = 0;
                while (pr == cu) {pr = cu;count++;cu = hash.charAt(count);}
                int pop = 10 - count%10;
                int k = 0;
                for (int i = LOW; i < HIGH; i++) {
                    if (hash.charAt(i * 10) == bt[k]) {k++;} else {k = 0;}
                    r[j] = k;
                }
                r[j] = (int)((((long)(HIGH - r[j])) * 299792458 / 1000000) - (long)pop * 299792458 / 10000000);
            } catch (Exception e) {}     
        }
        int N = r.length;
        int prom;
        for (int i = 0; i < N; i++) {
            int min = i;
            for (int j = i+1; j < N; j++) {
                if (r[j] < r[min]) {min = j;}
                prom = r[min];r[min] = r[i];r[i] = prom;prom = x[min];x[min] = x[i];x[i] = prom;prom = y[min];y[min] = y[i];y[i] = prom;
            }
        }
        double dx = (double) x[N-2];
        double dy = (double) y[N-2];
        double x2 = ((double) x[N-1]) - dx;
        double y2 = ((double) y[N-1]) - dy;
        double r1 = (double) r[N-2];
        double r2 = (double) r[N-1];
        double a = (-1)*2*x2;
        double b = (-1)*2*y2;
        double c = x2*x2 + y2*y2 + r1*r1 - r2*r2;
        double x0 = (-1)*a*c/(a*a+b*b);
        double y0 = (-1)*b*c/(a*a+b*b);
        double d = (r1*r1 - c*c/(a*a+b*b));
        double mult = Math.sqrt(d / (a*a+b*b));
        double X3 = (x0 + b * mult) + dx;
        double X4 = (x0 - b * mult) + dx;
        double Y3 = (y0 - a * mult) + dy;
        double Y4 = (y0 + a * mult) + dy;
        if ((Math.abs(X3) < 6378) && (Math.abs(Y3) < 6378)) {
            System.out.println(X3 + " " + Y3);
        } else {
            System.out.println(X4 + " " + Y4);
        }
    }
}
